#ifdef GL_ES
precision mediump float;
#endif
#pragma target 3.0
varying vec4 v_color;
varying vec2 v_texCoords;
varying vec2 v_armCoords;

uniform sampler2D u_texture;

uniform float cub;
uniform vec2 res;

vec4 multi();
vec4 mylinear3();
vec4 mylinear2();

void main() {
    vec4 color = v_color * multi();
	color.a*=color2.a;
    gl_FragColor = color;
}


vec4 multi()
{
	if(cub<=1.0)
	//	return mylinear2();
		return texture2D(u_texture, v_texCoords);
	
	int al=int(floor(cub-1.0))/2*2+1;
	float pt=(cub-float(al))/2.0;
	
	int i,j;
	
	vec4 allcolor=vec4(0.0);
	float wei=0.0;
	
	for(i=(1-al)/2;i<=(al-1)/2;i+=1)
	{
		for(j=(1-al)/2;j<=(al-1)/2;j+=1)
		{
			allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res);
			wei+=1.0;
		}
	}
	
//	i=(1-al)/2-1;
//	j=(1-al)/2;
//	while(j<=(al-1)/2)
//	{
//		allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt;
//		wei+=pt;
//		j+=1;
//	}
	
	
	for(j=(1-al)/2;j<=(al-1)/2;j+=1)
	{
		allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt;
		wei+=pt;
	}
	
	i=(al-1)/2+1;
	for(j=(1-al)/2;j<=(al-1)/2;j+=1)
	{
		allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt;
		wei+=pt;
	}
	
	j=(1-al)/2-1;
	for(i=(1-al)/2;i<=(al-1)/2;i+=1)
	{
		allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt;
		wei+=pt;
	}
	
	j=(al-1)/2+1;
	for(i=(1-al)/2;i<=(al-1)/2;i+=1)
	{
		allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt;
		wei+=pt;
	}
	
	i=(1-al)/2-1;
	j=(1-al)/2-1;
	allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt*pt;
	wei+=pt*pt;
		
	i=(1-al)/2-1;
	j=(al-1)/2+1;
	allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt*pt;
	wei+=pt*pt;
	
	i=(al-1)/2+1;
	j=(1-al)/2-1;
	allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt*pt;
	wei+=pt*pt;
	
	i=(al-1)/2+1;
	j=(al-1)/2+1;
	allcolor+=texture2D(u_texture, v_texCoords+vec2(i,j)/res)*pt*pt;
	wei+=pt*pt;
	
	
	allcolor/=wei;
	
	return allcolor;
}


vec4 mylinear3()
{
	float x=v_texCoords.x*res.x;
	float y=v_texCoords.y*res.y;
	
	float xs[4];
	float ys[4];
		
	vec4 cl=vec4(0.0);
	float weis=0.0;
	
	xs[1]=floor(x-0.5)+0.5;
	xs[2]=ceil(x-0.5)+0.5;
	ys[1]=floor(y-0.5)+0.5;
	ys[2]=ceil(y-0.5)+0.5;
	
	xs[0]=xs[1]-1.0;
	xs[3]=xs[2]+1.0;
	ys[0]=ys[1]-1.0;
	ys[3]=ys[2]+1.0;
	
	int i,j;
	float a=-0.75;
	
	for(i=0;i<4;i++)
	{
		for(j=0;j<4;j++)
		{
			vec4 cl1=texture2D(u_texture,vec2(xs[i],ys[j])/res);
			float z=abs(distance(vec2(x,y),vec2(xs[i],ys[j])));
			float wei=0.0;
			if(z>=2.0)
			{
				wei=0.0;
			}
			else if(z>=1.0)
			{
				wei=a*z*z*z-5.0*a*z*z+8.0*a*z-4.0*a;
			}
			else
			{
				wei=(a+2.0)*z*z*z-(a+3.0)*z*z+1.0;
			}
			cl+=cl1*wei;
			weis+=wei;
		}
	}
	
	vec4 cl7=cl/weis;
	return cl7;
}


vec4 mylinear2()
{
	float x=v_texCoords.x*res.x;
	float y=v_texCoords.y*res.y;
	
	float x1=floor(x-0.5)+0.5;
	float x2=ceil(x-0.5)+0.5;
	float y1=floor(y-0.5)+0.5;
	float y2=ceil(y-0.5)+0.5;
	
	float dis1=smoothstep (0.0,1.0,abs(x1-x));
	float dis2=smoothstep (0.0,1.0,abs(y1-y));
//	dis1=abs(x1-x);
//	dis2=abs(y1-y);
	
	vec4 cl1=texture2D(u_texture,vec2(x1,y1)/res);
	vec4 cl2=texture2D(u_texture,vec2(x1,y2)/res);
	vec4 cl3=texture2D(u_texture,vec2(x2,y1)/res);
	vec4 cl4=texture2D(u_texture,vec2(x2,y2)/res);
	
	vec4 cl5=dis1*cl3+(1.0-dis1)*cl1;
	vec4 cl6=dis1*cl4+(1.0-dis1)*cl2;
	
	vec4 cl7=dis2*cl6+(1.0-dis2)*cl5;
	
	return cl7;
}